// 002 u_script_executer_with_blobs
// 16 oct 2006

// -- (C) John COLIBRI 2006
// -- documentation: http://www.jcolibri.com

(*$r+*)

unit u_ib_blob_extractor;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl, ExtCtrls, ComCtrls, IBDatabase, DB, IBSQL, IBExtract,
  IBCustomDataSet, IBQuery, Grids, DBGrids, DBCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Panel2: TPanel;
    PageControl1: TPageControl;
    dir_: TTabSheet;
    extract_: TTabSheet;
    exit_: TButton;
    clear_: TButton;
    IBDatabase1: TIBDatabase;
    IBTransaction1: TIBTransaction;
    PageControl2: TPageControl;
    display_: TTabSheet;
    script__: TTabSheet;
    Memo1: TMemo;
    Panel3: TPanel;
    script_memo_: TMemo;
    base_directory_listbox_: TDirectoryListBox;
    base_file_listbox_: TFileListBox;
    Panel4: TPanel;
    table_names_: TButton;
    table_name_listbox_: TListBox;
    blob_table_names_: TButton;
    blob_table_name_listbox_: TListBox;
    extract__: TButton;
    save_edit_: TEdit;
    save_script_: TButton;
    procedure FormCreate(Sender: TObject);
    procedure clear_Click(Sender: TObject);
    procedure exit_Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure base_file_listbox_Click(Sender: TObject);
    procedure base_directory_listbox_Change(Sender: TObject);
    procedure table_names_Click(Sender: TObject);
    procedure blob_table_names_Click(Sender: TObject);
    procedure extract__Click(Sender: TObject);
    procedure save_script_Click(Sender: TObject);
  private
  public
  end;

var
  Form1: TForm1;

  implementation
    uses u_c_log, u_c_display, u_file, u_dir
        , u_c_ini_file
        , u_types_constants
        , u_strings
        , u_ibx
        , u_c_ib_blob_script_extractor
        ;

    {$R *.DFM}

   
    const k_initial_path= 'C:\programs\fr\bdd\interbase\_data\employee\';
            k_file_name= 'employee_6.gdb';
            k_extension= '.*';

          // -- ini keys
          k_save_path= k_initial_path;
          k_save_name= k_file_name;

          k_load_base_path_ini_key=      'load_base_path';
          k_load_base_file_name_ini_key= 'load_base_file_name';

    var g_base_path: String= k_initial_path;
        g_base_file_name: String= k_file_name;

        g_c_ini_file: c_ini_file= Nil;

    procedure handle_file(p_path, p_file_name: String);
      begin
        display(p_file_name);
      end; // handle_file

    // -- events

    procedure TForm1.FormCreate(Sender: TObject);
      var l_index_of_script: Integer;
      begin
        initialize_display(Memo1.Lines);
        initialize_default_log;

        g_c_ini_file:= c_ini_file.create_ini_file('');
        with g_c_ini_file do
        begin
          // -- whatever is in "fig_ini.txt"
          load_from_default_file;

          // -- initialize the variables with INI or, if none, with constants
          g_base_path:= f_initialize_parameter(k_load_base_path_ini_key, k_save_path);
          g_base_file_name:= f_initialize_parameter(k_load_base_file_name_ini_key, k_save_name);
        end; // with g_c_ini_file

        save_edit_.Text:= ChangeFileExt(g_base_file_name, '');

        set_directory_listbox_directory(base_directory_listbox_, g_base_path);

        with base_file_listbox_, Items do
        begin
          l_index_of_script:= IndexOf(g_base_file_name);
          // display(IntToStr(l_index_of_script));
          If l_index_of_script>= 0
            then ItemIndex:= l_index_of_script;
        end;
      end; // FormCreate

    procedure TForm1.clear_Click(Sender: TObject);
      begin
        clear_display;
      end; // clear_Click

    procedure TForm1.base_directory_listbox_Change(Sender: TObject);
      begin
        with base_directory_listbox_ do
          g_base_path:= GetItemPath(ItemIndex)+ '\';
        g_c_ini_file.set_parameter(k_load_base_path_ini_key, g_base_path);
      end; // base_directory_listbox_Change

    procedure TForm1.base_file_listbox_Click(Sender: TObject);
        // -- the file clicked in the bottom list_box
      begin
        with base_file_listbox_ do
          g_base_file_name:= Items[ItemIndex];

        initialize_ib_database(g_base_path+ g_base_file_name, 'SYSDBA', 'masterkey', IbDatabase1);
        f_open_ib_database('open', IbDatabase1);

        g_c_ini_file.set_parameter(k_load_base_file_name_ini_key, g_base_file_name);
        save_edit_.Text:= ChangeFileExt(g_base_file_name, '');
      end; // base_file_listbox_

    procedure TForm1.exit_Click(Sender: TObject);
      begin
        Close;
      end; // exit_Click

    procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
      begin
        g_c_ini_file.save_to_default_file;
      end; // FormClose

    var g_c_tablename_list: tStringList= Nil;

    procedure TForm1.table_names_Click(Sender: TObject);
      begin
        g_c_tablename_list.Free;
        g_c_tablename_list:= f_c_table_names(IbDatabase1);

        table_name_listbox_.Items.Assign(g_c_tablename_list);
      end; // table_names_Click

    procedure TForm1.blob_table_names_Click(Sender: TObject);
      var l_table_name_index: Integer;
          l_table_name: String;
      begin
        if g_c_tablename_list= Nil
          then table_names_Click(Nil);

        blob_table_name_listbox_.Items.Clear;
        with g_c_tablename_list do
        begin
          for l_table_name_index:= 0 to Count- 1 do
          begin
            l_table_name:= Strings[l_table_name_index];
            with f_c_field_info_ibquery(IbDatabase1, l_table_name) do
            begin
              display(l_table_name);
              while not Eof do
              begin
                display('  '+ Format('%-20s %-10s %5d %5d',
                    [Trim(Fields[0].AsString), Trim(Fields[1].AsString), Fields[2].AsInteger, Fields[3].AsInteger]) );
                if Trim(Fields[1].AsString)= 'BLOB'
                  then blob_table_name_listbox_.Items.Add(l_table_name);

                Next;
              end; // while not Eof

              Free;
            end; // with f_c_field_info_ibquery
          end; // for l_table_name_index
        end; // with g_c_tablename_list
      end; // blob_table_names_Click

    procedure TForm1.extract__Click(Sender: TObject);

      procedure extract_the_script(p_table_name: String);
        var l_c_ib_blob_script_extractor: c_ib_blob_script_extractor;
        begin
          l_c_ib_blob_script_extractor:= c_ib_blob_script_extractor.create_ib_blob_script_extractor('ib_blob', IbDatabase1);
          with l_c_ib_blob_script_extractor do
          begin
            extract_script(p_table_name);
            script_memo_.Lines.Text:= script_memo_.Lines.Text+ m_c_result_script.Text+ k_new_line;

            Free;
          end; // with l_c_ib_blob_script_generator
        end; // extract_the_script

      var l_table_name_index: Integer;

      begin // extract__Click
        script_memo_.Lines.Clear;

        with blob_table_name_listbox_, Items do
          for l_table_name_index:= 0 to Count- 1 do
            extract_the_script(Trim(Items[l_table_name_index]));
      end; // extract__Click

    procedure TForm1.save_script_Click(Sender: TObject);
      var l_file_name: String;
      begin
        l_file_name:= g_base_path+ save_edit_.Text+ '_blob_script.txt';
        display(l_file_name);
        script_memo_.Lines.SaveToFile(l_file_name);
      end; // save_script_Click

end.


